structure Top =
    struct
	structure SL = SL()
	structure V = Var()
	structure E = Env(structure V=V;
			  structure SL = SL)

	(* String names are used for parsing *)
	structure SN = StringName();
	structure N = deBruijnName();
	(* and string tests... *)
	structure ST = StringTest(structure N=SN;
				  structure SL = SL)
	structure T = Test(structure N=N;
			   structure SL=SL)
	(* and string actions... *)
	structure SAct = StringAction(structure N=SN);
	structure Act = Action(structure N=N)
	(* and string agents... *)
	structure SA = StringAgent(structure T=ST;
			     structure Act=SAct)

	structure D = Distinction(structure T = T;
				  structure SL = SL)
	structure A = BruinAgent(structure SL = SL;
				 structure T=T;
				 structure Act=Act;
				 structure E=E;
				 structure V=V)
	structure H = HashTable();
	structure O = BruinOpenSem(structure B=A;
				    structure D=D;
				    structure H=H)

	structure SP = StringPropVar(structure Agt=SA)
	structure SF = StringFormula(structure Act=SAct;
				     structure PropVar = SP)

	(* Model Checking stuff *)
(* 	structure Bool = Boolean(structure T=T; *)
(* 				 structure N=N) *)
	structure Bool = T
	structure McAgent = McAgent(structure B=Bool;
				    structure Act=Act;
				    structure AG=A)
	structure PV = PropVar(McAgent)
	structure F = Formula(structure PropVar=PV;
			      structure Constant=Constant;
			      structure Action=Act)
	structure NS = NameSubstitution(structure Name=N;
					structure Boolean=Bool)
	structure ASS = AgentSubSem(structure Agent=McAgent;
				    structure NameSubstitution = NS;
				    structure Boolean= Bool)
	structure Cond = Condition(structure NameSubstitution = NS;
				   structure Formula = F)
	structure DF = DefList(structure Formula = F)
	structure SQ = Sequent(structure Formula = F;
			       structure Condition = Cond;
			       structure DefList = DF;
			       structure Agent = McAgent)
	structure MC = ModelChecker(structure Sequent = SQ;
				    structure AgentSubSem = ASS)
	structure EQ = EquivalenceChecker(structure ModelChecker = MC)
	(* end Model Checking Stuff *)


	(* **** sort checking *)
	structure SoN = SortName()
	structure SoAct = SortAction(structure N=SoN)
	structure SoT = SortTest(structure N=SoN;
				 structure SL=SL)
	structure SoA = SortAgent(structure T=SoT;
				  structure Act=SoAct;
				  structure SL=SL)
	structure EqR = Eqrel(structure SL=SL)
	structure SS = SSort(structure Name=SoN;
			     structure Agent=SoA;
			     structure Env=E;
			     structure Slist=SL;
			     structure Eqrel=EqR)

	(* **** end sort checking *)


	structure Cmd = Commands(structure A=SA;
				 structure F=SF)


(* 	structure PILrVals =                                          *)
(* 	    PILrValsFun(structure Token = LrParser.Token              *)
(* 			structure Agent = SA                          *)
(* 			structure Commands = Cmd                      *)
(* 			structure Prop = SP                           *)
(* 			structure F = SF)                             *)
(*                                                                    *)
(* 	structure PILex =                                             *)
(* 	    PILexFun(structure Tokens = PILrVals.Tokens)              *)
(*                                                                    *)
(* 	structure PIParser =                                          *)
(* 	    JoinWithArg(structure ParserData = PILrVals.ParserData    *)
(* 		 structure Lex = PILex                                *)
(* 		 structure LrParser = LrParser)                       *)

	structure TT = TopCode(
		structure SL=SL
		structure V=V
		structure E=E
		structure SN=SN
		structure N=N
		structure ST=ST
		structure T=T
		structure SAct=SAct
		structure Act=Act
		structure SA=SA
		structure D=D
		structure A=A
		structure H=H
		structure O=O
		structure SP=SP
		structure SF=SF
		structure McAgent=McAgent
		structure PV=PV
		structure F=F
		structure NS=NS
		structure ASS=ASS
		structure Cond=Cond
		structure DF=DF
		structure SQ=SQ
		structure MC=MC
		structure EQ=EQ
		structure SoN=SoN
		structure SoAct=SoAct
		structure SoT=SoT
		structure SoA=SoA
		structure EqR=EqR
		structure SS=SS
		structure Cmd=Cmd
(* 		structure PILrVals = PILrVals    *)
(* 		structure PILex = PILex          *)
(* 		structure PIParser = PIParser    *)
		    );

	val toplevel = TT.toplevel
	fun toptest() =
	    TT.cmdloop (fn _ => TextIO.inputLine TextIO.stdIn) (E.empty,E.empty);
    end
